/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VDmTablecopyRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VDmTablecopy extends TableImpl<VDmTablecopyRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_dm_tablecopy</code>
     */
    public static final VDmTablecopy V_DM_TABLECOPY = new VDmTablecopy();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VDmTablecopyRecord> getRecordType() {
        return VDmTablecopyRecord.class;
    }

    /**
     * The column <code>common_dd.v_dm_tablecopy.fk_element</code>.
     */
    public final TableField<VDmTablecopyRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_dm_tablecopy.schemaname</code>.
     */
    public final TableField<VDmTablecopyRecord, String> SCHEMANAME = createField(DSL.name("schemaname"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_dm_tablecopy.sourceschema</code>.
     */
    public final TableField<VDmTablecopyRecord, String> SOURCESCHEMA = createField(DSL.name("sourceschema"), SQLDataType.CLOB, this, "");

    private VDmTablecopy(Name alias, Table<VDmTablecopyRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VDmTablecopy(Name alias, Table<VDmTablecopyRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_dm_tablecopy" as  SELECT t_dm_tabledef.fk_element,
         t_dm_tabledef.schemaname,
         t_dm_tablecopy.sourceschema
        FROM (common_dd.t_dm_tabledef
          JOIN common_dd.t_dm_tablecopy ON ((t_dm_tablecopy.fk_tabledef = t_dm_tabledef.pk)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_dm_tablecopy</code> table reference
     */
    public VDmTablecopy(String alias) {
        this(DSL.name(alias), V_DM_TABLECOPY);
    }

    /**
     * Create an aliased <code>common_dd.v_dm_tablecopy</code> table reference
     */
    public VDmTablecopy(Name alias) {
        this(alias, V_DM_TABLECOPY);
    }

    /**
     * Create a <code>common_dd.v_dm_tablecopy</code> table reference
     */
    public VDmTablecopy() {
        this(DSL.name("v_dm_tablecopy"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VDmTablecopy as(String alias) {
        return new VDmTablecopy(DSL.name(alias), this);
    }

    @Override
    public VDmTablecopy as(Name alias) {
        return new VDmTablecopy(alias, this);
    }

    @Override
    public VDmTablecopy as(Table<?> alias) {
        return new VDmTablecopy(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VDmTablecopy rename(String name) {
        return new VDmTablecopy(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDmTablecopy rename(Name name) {
        return new VDmTablecopy(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VDmTablecopy rename(Table<?> name) {
        return new VDmTablecopy(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmTablecopy where(Condition condition) {
        return new VDmTablecopy(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmTablecopy where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmTablecopy where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmTablecopy where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmTablecopy where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmTablecopy where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmTablecopy where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VDmTablecopy where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmTablecopy whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VDmTablecopy whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
